package core

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/expression"
	"git.urbach.dev/cli/q/src/types"
)

// ExpressionToMemory puts the result of an expression into the specified memory address.
func (f *Function) ExpressionToMemory(node *expression.Expression, memory asm.Memory) (types.Type, error) {
	value, err := f.Evaluate(node)

	if err != nil {
		return nil, err
	}

	f.ValueToMemory(value, memory)
	return value.Type(), nil
}
